// deravel.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "deravel.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

static CStdioFile fin;
static CStdioFile fout;

#define MAXLINES 65535
static CString rLines[MAXLINES];

void DeRavel( long, long );

void DeRavel( long lLine, long lDepth )
{
  long lCurDepth;
  long lCurLine;

  lCurDepth = lDepth + 1;
  lCurLine = lLine;
  if ( lCurLine > 1 )
  {
    while ( atol( rLines[--lCurLine] ) >= lDepth )
    {
      if ( lCurLine == 1 )
        break;
    }
  }

  while ( lCurLine < lLine )
  {
    if ( atol( rLines[lCurLine] ) == lDepth )
    {
      fout.WriteString( rLines[lCurLine] );
      DeRavel( lCurLine, lCurDepth );
    }
    lCurLine++;
  }
}

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		CString strHello;
		strHello.LoadString(IDS_HELLO);
		cout << (LPCTSTR)strHello << endl;

    if (argc != 2)
    {
      nRetCode = 2;
    }
    else
    {
      long x = 0;

      fin.Open(argv[1], CFile::modeRead, NULL);
      fin.ReadString( rLines[x] );
      rLines[x++] += "\n";
      while ( fin.ReadString( rLines[x] ) != NULL )
      {
        rLines[x] += "\n";
        x++;
      }
      fin.Close();

      fout.Open(argv[1], CFile::modeCreate | CFile::modeWrite, NULL);
      fout.WriteString( rLines[0] );
      DeRavel( x, 0 );
      fout.Close();
    }
	}

	return nRetCode;
}


